Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
给定一列整形数组和一个目标数,返回数组中和为目标数的两个数字的序列。
假定每组输入都有且仅有一个精确解,并且不能多次使用同一元素。
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
1. 暴力算法
先固定第一个数,然后从固定的数往后面搜索第二个数,这个原始的暴力破解法时间复杂度接近n^2,用时223ms。
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
vector<int> ans;
for (int i = 0; i < nums.size(); i++)
{
for (int j = i + 1; j < nums.size(); j++)
{
if (target == nums[i] + nums[j])
{
ans.push_back(i);
ans.push_back(j);
return ans;
}
}
}
}
};
2.哈希表
借鉴leetcode社区回答,使用哈希表。复杂度n,6ms。
tips:
1.
– hashmap.begin() : 返回首元素迭代器数值
– hashmap.end() : 返回末尾元素下一元素迭代器数值
– hashmap.find() : 返回值为key的位置,若找不到,返回和end()相同的值。
2.
– hashmap[nums[i]] = i
放在判断下面执行,若放在上面,当target是某元素的2倍时,会返回错误值。
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target)
{
unordered_map<int, int> hashmap;
for(int i = 0; i < nums.size(); ++i)
{
if(hashmap.find(target - nums[i]) != hashmap.end())
{
return vector<int>{hashmap[target - nums[i]], i};
}
hashmap[nums[i]] = i;
}
return vector<int>();
}
};